;FASTCALL.H
; Idea by: Andreas Ess
; Code by: Sam Davies/Andreas Ess
;(C) 1996 by Sam Davies/Andreas Ess
;
;Include this header file if you want faster calls before the .end of your
;.ASM file. Then, decide which CALL_'s should be replaced by a FAR FASTER
;normal call, and replace it by a call with a preceding label.
;At the end of your file, make a table of the labels, called AddrTable:
;AddrTable:
; .db ?           ;numbers of the calls to this function in your whole program
; .dw TheFunction ;the function name
; .dw L1, ... ;   ;the labels where it should get called
; .db ?
; ...
; TotalAddr = ?   ;number of different functions
;
;A quick example:
;first:
; CALL_(DoScrolling)
;
;replace by:
;ScrollCall1: call DoScrolling
;before the end of the file:
; TotalAddr = 1
;AddrTable:
; .db 1
; .dw DoScrolling
; .dw ScrollCall1
;
;voila!
;
;You can use this for loads, too(Text, Sprites), but:
;Attention!!!
;when u use:
; * LD DE, (ADDR)
; * LD (ADDR), DE
; * LD BC, (ADDR)
; * LD (ADDR), BC
; * LD IX, (ADDR)
; * LD (ADDR), IX
; * LD IY, ...
;then you have to add one to the label in the table:
; .db 1
; .dw String
; .dw LString+1
;
;Everything clear?
;		Have fun - and most of all - FAST programs
;			Sam & Andreas

PrepFastCall:
 ld      ix, AddrTable
 ld      bc, (PROGRAM_ADDR)
 add     ix, bc

 ld      b, TotalAddr
ReplaceAddr:
 ld      c, (ix+0)
 ld      e, (ix+1)
 ld      d, (ix+2)
 inc     ix
 inc     ix
 inc     ix
 ld      hl, (PROGRAM_ADDR)
 add     hl, de
 ex      de, hl
ReplaceAddr_ILoop:		;DE contains address of function
 push    de
 ld      e, (ix+0)
 ld      d, (ix+1)

 ld      hl, (PROGRAM_ADDR)
 add     hl, de
 inc     hl
 pop     de
 ld      (hl), e
 inc     hl
 ld      (hl), d

 inc     ix
 inc     ix
 dec     c
 jr      nz, ReplaceAddr_ILoop
 djnz    ReplaceAddr
 ret
