;
;Shows the hiscore
;
HiScoreShow:
 push hl
 push bc
 CALL_(ClearDBuf)
 lea(HiScrScreen)
 mov  bc, 16
 CALL_(DeGCP)
 CALL_(Copy2Active)
 mov  hl, CURSOR_ROW
 mov  (hl), 2
 inc  hl
 mov  (hl), 0
 mov  bc, (PROGRAM_ADDR)
 mov  hl, H_Score
 add  hl, bc
 ex   de, hl
 mov  hl, H_Name
 add  hl, bc
 mov  b, 3          ;HL contains name, DE score
 mov  c, 3
HiScoreShow_1:
 push bc
 ROM_CALL(D_ZT_STR)
 mov  a, 15
 mov  (CURSOR_COL), a
 push hl
 ex   de, hl
 push hl
 call LD_HL_MHL
 ROM_CALL(D_HL_DECI)
 pop  hl
 inc  hl
 inc  hl
 ex   de, hl
 pop  hl
 pop  bc
 xor  a
 mov  (CURSOR_COL), a
 mov  a, c
 mov  (CURSOR_ROW), a
 inc  c
 loop HiScoreShow_1
 mov  hl, $0400
 mov  (CURSOR_ROW), hl
 lea(H_Title)
 ROM_CALL(D_ZT_STR)
#ifndef _LITE
 CALL_(WaitAWhile)
 CALL_(SpecialShow)
#else
 CALL_(Copy2Active)
#endif
 pop  bc
 pop  hl
 ret

;
;HiScoreHand: the hiscore handler
;
HiScoreHand:
;** Now check for hiscore
 mov  hl, H_Score-2
 mov  de, (PROGRAM_ADDR)
 add  hl, de
 mov  b, 3
SearchHScr:
 inc  hl
 inc  hl
 push hl
 call LD_HL_MHL
 mov  de, (SCORE)
 call CP_HL_DE
 jb   HiScr_Found
 pop  hl
 loop SearchHScr
 ret
HiScr_Found:
 pop  hl
;First, move the others back:
 push bc
 push hl
 mov  a, b
 cmp  1
 jz   HiScr_NoBack
 dec  b
 shl  b
 mov  c, b
 mov  b, 0
 push bc
 add  hl, bc
 inc  hl
 mov  d, h
 mov  e, l
 dec  de
 dec  de
 ex   de, hl
 lddr
 ;SCORE MOVED BACK NOW
 pop  bc
 shl  c      ;NAME NEEDS 4 TIMES AS MUCH BYTES
 shl  c
 lea(H_Name)
 mov  de, 23 ;Go to the end of H_Name
 add  hl, de
 mov  d, h
 mov  e, l
 push de
 mov  de, -8
 add  hl, de
 pop  de
 lddr
HiScr_NoBack:
 pop  hl
 pop  bc
 mov  de, (SCORE)
 mov  (hl), e
 inc  hl
 mov  (hl), d
 lea(H_Name)
 mov  a, 3
 sub  b
 mov  b, 0
 mov  c, a
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 push hl
 mov  (hl), '-'
 inc  hl
 mov  (hl), '-'
 inc  hl
 mov  (hl), '-'
 inc  hl
 mov  (hl), '-'
 inc  hl
 mov  (hl), '-'
 inc  hl
 mov  (hl), '-'
 inc  hl
 mov  (hl), '-'
 CALL_(HiScoreShow)
 pop  hl
 mov  e, c
 inc  e
 inc  e
 mov  d, 0
 mov  (CURSOR_ROW), de
 mov  b, 7
HiEnter:
 CALL_(GetLetter)
 jc   FillSpace
 mov  (hl), a
 inc  hl
 loop HiEnter
 ret
FillSpace:
 mov  a, ' '
FillSpace_1:
 mov  (hl), a
 inc  hl
 loop FillSpace_1
 ret

;
;GetLetter: gets a letter(magnus hagander)
;
GetLetter:
  push hl
  push bc
  ld   hl,(PROGRAM_ADDR)
  ld   de,ASCII_Table-1   ;Point to one before, since we always inc once
  add  hl,de              ;HL now points right
ConvertLoop:
  push hl
  call GET_KEY                 ;ACC holds key
  pop  hl
  and  a
  jr   z,ConvertLoop
  cp   K_ENTER
  jz   EnterPressed_Hi
  push hl                      ;save away...
  ld   b,a
  ld   c,0
ConversionLoop:
  inc  hl
  djnz ConversionLoop          ;After this, we have the correct offset...
  ld   a,(HL)
  pop  hl
  and  a
  jr   z,ConvertLoop           ;Invalid key
  ROM_CALL(TX_CHARPUT)         ;Show the char
  CALL_(Copy2Active)
  pop  bc
  pop  hl
  or   a
  ret                          ;Value is in acc
EnterPressed_Hi:
  pop  bc
  pop  hl
  scf
  ret
