VarNLen = 	TEXT_MEM2+58
NrFiles = 	TEXT_MEM2+59
FilePt =        TEXT_MEM2+60 ;30*2 byte pointer to files
NameBuf = 	TEXT_MEM2+120  ;Actual name, up to 9 chars
NamePt  = 	TEXT_MEM2+129  ;pointer

LoadLvl:
 ROM_CALL(CLEARLCD)
 ld  hl, GRAPH_MEM+11
 ld  (NamePt), hl
 ld  hl, $0300
 ld  ($800C), hl
 ld  hl, (PROGRAM_ADDR)
 ld  de, LoadStr
 add hl, de
 ROM_CALL(D_ZT_STR)
 CALL_(SrchLFile)
 ld  a, c
 and a
 jr  z, ExitLvlLoad
 dec c
 ld  b, 0
LoadLvl_Loop:
 CALL_(Invert)
LoadLvl_Key:
 halt
 call GET_KEY
 and  a
 jr   z, LoadLvl_Key
 CALL_(Invert)
 cp   K_LEFT
 jr   nz, TestRight
 ld   a, b
 and  a
 jr   z, LoadLvl_Loop
 dec  b
 jr   LoadLvl_Loop
TestRight:
 cp   K_RIGHT
 jr   nz, TestDown
 ld   a, b
 cp   c
 jr   z, LoadLvl_Loop
 inc  b
 jr   LoadLvl_Loop
TestDown:
 cp   K_DOWN
 jr   nz, TestUp
 ld   a, b
 add  a, 3
 cp   c
 jr   nc, LoadLvl_Loop
 ld   b, a
 inc  b
 jr   LoadLvl_Loop
TestUp:
 cp   K_UP
 jr   nz, TestEnter
 ld   a, b
 sub  4
 jr   c, LoadLvl_Loop
 ld   b, a
 jr   LoadLvl_Loop
TestEnter:
 cp   K_ENTER
 jr   nz, TestExit
 ld   h, 0
 ld   l, b
 add  hl, hl
 ld   de, FilePt
 add  hl, de
 call LD_HL_MHL
 ret
TestExit:
 cp   K_EXIT
 jr   nz, LoadLvl_Loop
ExitLvlLoad:
 ld   hl, 0
 ld   ($800C), hl
 ret

Invert:
 push bc
 push af
 ld  h, 0
 ld  a, b
 and 00000011b
 ld  l, a
 add hl, hl
 add hl, hl
 ld  a, b
 and 11111100b
 rra
 rra
 and a
 jr  z, AfterAddLoop
 ld  de, 112
 ld  b, a
InvertLoop_Add:
 add hl, de
 djnz InvertLoop_Add
AfterAddLoop:
 ld  de, VIDEO_MEM+128
 add hl, de
 ld  c, 7
InvertLoop:
 ld  b, 4
InvertLoop_1:
 ld  a, (hl)
 xor 255
 ld  (hl), a
 inc hl
 djnz InvertLoop_1
 ld  de, 12
 add hl, de
 dec c
 jr  nz, InvertLoop
 pop af
 pop bc
 ret

SrchLFile:
 ld  hl, $0801
 ld  ($8333), hl
 ld  hl, VAT_START
 ld  ix, FilePt
 ld  c, 0
RPLoop:
 ld  a, (hl)
 cp  $C			;is this a string?
 jr  nz, NoString
 dec hl                 ;load de with address
 ld  e, (hl)
 dec hl
 ld  d, (hl)
 ld  (ix), e            ;save it in TEXT_MEM2
 ld  (ix+1), d
 inc de                 ;read first byte of string
 inc de
 ld  a, (de)
 cp  $AE
 jr  nz, NoString1
 inc ix
 inc ix
 dec hl
 ld  b, (hl)            ;length of the name:
 dec hl
 ld  de, NameBuf
DecodeName:
 ld   a, (hl)
 dec  hl
 ld   (de), a
 inc  de
 djnz DecodeName
 xor  a
 ld   (de), a
;Name decoded, show the string
 ex   de, hl
 ld   hl, NameBuf
 ROM_CALL(D_ZM_STR)
 ex   de, hl
;Update cursor position X=X/32*32+1
 ld   a, ($8333)
 and  11100000b
 add  a, 33
 cp   98
 jr   c, CursorDone
 ld   a, ($8334)
 add  a, 7
 ld   ($8334), a
 ld   a, 1
CursorDone:
 ld   ($8333), a
;Increment number of files
 inc  c
 ld   a, c
 cp   30
 ret  z
VatControl:
 ld   de, (VAT_END)
 call CP_HL_DE
 jr   nc, RPLoop
EndSearch:
 ret
NoString:
 dec  hl
 dec  hl
NoString1:
 dec  hl
 ld   e, (hl)
 inc  e
 ld   d, 0
 or   a
 sbc  hl, de
 jr   VatControl

LoadStr: .db "SELECT A FILE:",0
