;
;Built-in Level editor:
;
LevelEditor:
 ld  hl, (PROGRAM_ADDR)
 ld  de, Level
 add hl, de
 ld  (LEVELPT), hl
 xor a
 ld  (LEVELY), a
EDS1: call EDrwScreen
 ld  a, 10000000b
 ld  (Mask), a
 ld  b, 0
 ld  c, 60
KeyLoop:
 CALL_(PointChg)
WaitKey:
 call GET_KEY
 and  a
 jr   z, WaitKey
 CALL_(PointChg)
 cp   K_DOWN
 jr   z, MoveDown
 cp   K_LEFT
 jr   z, MoveLeft
 cp   K_RIGHT
 jr   z, MoveRight
 cp   K_UP
 jr   z, MoveUp
 cp   K_F1
 CALL_Z(ChangeStone1)
 cp   K_F2
 JUMP_Z(ChangeStone2)
 cp   K_F3
 JUMP_Z(ChangeBoth)
 cp   $37
 JUMP_Z(ExitEditor)
 cp   $0F
 JUMP_Z(ClearLevel)
 jr   KeyLoop
MoveDown:
 ld   a, (LEVELY)
 and  a
 jr   z, KeyLoop
 dec  a
 ld   (LEVELY), a
 inc  c
 inc  c
 ld   a, c
 cp   62
 jr   nz, KeyLoop
 ld   hl, (LEVELPT)
 dec  hl
 dec  hl
 ld   (LEVELPT), hl
 ld   c, 60
EDS2: call EDrwScreen
 jr   KeyLoop
MoveLeft:
 ld   a, b
 and  a
 jr   z, KeyLoop
 dec  b
 dec  b
 ld   a, (Mask)
 add  a, a
 ld   (Mask), a
 jr   KeyLoop
MoveRight:
 ld   a, b
 cp   14
 jr   z, KeyLoop
 inc  b
 inc  b
 ld   a, (Mask)
 shr  a
 ld   (Mask), a
 JUMP_(KeyLoop)
MoveUp:
 ld   a, (LEVELY)
 cp   253
 JUMP_Z(KeyLoop)
 inc  a
 ld   (LEVELY), a
 dec  c
 dec  c
 ld   a, c
 and  a
 JUMP_NZ(KeyLoop)
 ld   hl, (LEVELPT)
 inc  hl
 inc  hl
 ld   (LEVELPT), hl
 ld   c, 2
EDS3: call EDrwScreen
 JUMP_(KeyLoop)

ChangeStone1:
 ld   hl, (LEVELPT)
 ld   a, 60
 sub  c
 ld   e, a
 ld   d, 0
 add  hl, de
 ld   a, (Mask)
 xor  (hl)
 ld   (hl), a
EDS4: call EDrwScreen
 xor  a
 ret

ChangeStone2:
 ld   hl, (LEVELPT)
 ld   a, 60
 sub  c
 ld   e, a
 ld   d, 0
 add  hl, de
 inc  hl
 ld   a, (Mask)
 xor  (hl)
 ld   (hl), a
EDS6: call EDrwScreen
 JUMP_(KeyLoop)

ChangeBoth:
 CALL_(ChangeStone1)
 JUMP_(ChangeStone2)

ClearLevel:
 push bc
 ld   hl, (LEVELPT)
 ld   bc, 512
 ld   d, h
 ld   e, l
 inc  de
 ld   (hl), 0
 ldir
EDS5: call EDrwScreen
 pop  bc
 JUMP_(KeyLoop)

ExitEditor:
 ld   hl, (LEVELPT)
 ld   de, (LEVELPT)
 ld   bc, 510
 add  hl, bc
 ex   de, hl
 ldi
 ldi
 JUMP_(Title)

;
;EDrwScreen: draws screen
;
EDrwScreen:
 push bc
 ROM_CALL(CLEARLCD)
 ld  hl, (PageBAddr)
 ld  d, h
 ld  e, l
 inc de
 ld  (hl), 0
 ld  bc, 1023
 ldir
 ld  hl, (LEVELPT)
 ld  b, 30
DrawLoop:
 ld   a, b
 add  a, a
 ld   c, a
 ld   d, $80
 push bc
 ld   b, 0
BitLoopMap:
 ld   a, (hl)
 and  d
DrawBox1C1: call nz, DrawBox2
 inc  hl
 ld   a, (hl)
 and  d
DrawBox2C1: call nz, DrawBox1
 dec  hl
 inc  b
 inc  b
 shr  d
 jnz  BitLoopMap
 pop  bc
 inc  hl
 inc  hl
 djnz DrawLoop
 pop bc
 ret

;
;DrawBox1
;
DrawBox1:
 push de
 push hl
 push bc
 ld   a, 63
 sub  c
 ld   c, a
 ROM_CALL(FIND_PIXEL)
 ld   de, (PageAAddr)
 add  hl, de
 ld   c, a
 or   (hl)
 ld   (hl), a
 ror  c
 ld   a, (hl)
 or   c
 ld   (hl), a
 ld   de, 16
 add  hl, de
 ld   a, (hl)
 or   c
 ld   (hl), a
 rol  c
 ld   a, (hl)
 or   c
 ld   (hl), a
 pop bc
 pop hl
 pop de
 ret

;
;DrawBox2
;
DrawBox2:
 push hl
 push de
 push bc
 ld   a, 63
 sub  c
 ld   c, a
 ROM_CALL(FIND_PIXEL)
 ld   de, (PageBAddr)
 add  hl, de
 ld   c, a
 or   (hl)
 ld   (hl), a
 ror  c
 ld   a, (hl)
 or   c
 ld   (hl), a
 ld   de, 16
 add  hl, de
 ld   a, (hl)
 or   c
 ld   (hl), a
 rol  c
 ld   a, (hl)
 or   c
 ld   (hl), a
 pop bc
 pop de
 pop hl
 ret

;
;PointChg: changes point at b=x, c=y
;
PointChg:
 push bc
 push hl
 push af
 ld   a, 63
 sub  c
 ld   c, a
 ROM_CALL(FIND_PIXEL)
 ld   de,$FC00
 add  hl,de
 xor  (hl)
 ld   (hl),a
 pop  af
 pop  hl
 pop  bc
 ret

