#define   P_HI      %11000000        ;code to put port high
#define   P_LO      %11111100        ;code to put port low
#define   C_PORT    %00000111        ;addres of com port

PlayNote:
 ld     hl, WAITORPLAY
 dec    (hl)
 ret    nz
 push   bc
 ld     (hl), 2

 ld     a, (SONGLENG)
 inc    a
 cmp    NUM_NOTES
 jnz    GoOn_PlayNote
 ld     hl, (PROGRAM_ADDR)
 ld     de, Song1
 add    hl, de
 ld     (SONGPT), hl
 xor    a
GoOn_PlayNote:
 ld     (SONGLENG), a

 ld     hl, (SONGPT)
 ld     b, (hl)
 ld     c, b
 ld     (current_tone), bc
 inc    hl
 ld     (SONGPT), hl


 ld     a, 64
 ld	(current_length),a

 ld	a,b
 and    a
 jr	z,delay_for_0
set_low:
 ld  a,P_LO            ;set w(white) and r(red) low, 0 0
 out (7),a             ;output 0 0

 CALL_(delay)          ;pause for d ticks

set_high:
 ld  a,P_HI            ;set w & r high, 1 1 (default)
 out (7),a             ;output 1 1,make sure this is the last to be outputted!
		       ;pulse the port high, must be high when quiting

 CALL_(delay)          ;pause for d ticks

 ld     hl, current_length
 dec    (hl)
 jr	nz,set_low

all_ok:
 pop    bc
 ret


;==========================================
;   Delay Loop
;==========================================
delay:
 push	bc
 ld     a, (current_tone)
 and    a
 ret    z
 ld	b, a
delay2:				;delay loop
 djnz delay2
 pop	bc
 ret
;==========================================
;   Delay Two
;==========================================
delay_for_0:
 xor    a
 ld	(current_tone),a
 ld	a, 1
delays:
 CALL_(delaya)
 dec	a
 jr	nz,delays
 jr	all_ok
delaya:				;delay loop
 push	af
 push	bc
 ld 	bc,2500
delay2a:
 dec	bc
 ld	a,b
 or	c
 jr	nz,delay2a
 pop	bc
 pop	af
 ret

E3  =247
F3  =232
FP3 =218
G3  =205
GP3 =192
A3  =180
Bb3 =168
B3  =158
C4  =148
CP4 =138
D4  =129
DP4 =120
E4  =113
F4  =105
FP4  =98
G4   =91
GP4  =85
A4   =79
Bb4  =73
B4   =68
C5   =62
CP5  =58
D5   =53

NUM_NOTES = 23*8

Song1:
 .db C4,0,C4,0,Bb3,C4,F4,0
 .db 0,0,DP4,0,C4,0,F4,0
 .db 0,0,F4,DP4,C4,0,Bb3,0
 .db 0,0,G3,0,0,0,Bb3,C4
 .db C4,0,C4,0,Bb3,C4,F4,0
 .db 0,0,DP4,0,C4,0,F4,0
 .db 0,0,F4,DP4,C4,0,G4,0
 .db 0,0,F4,DP4,F4,0,C4,0
 .db C4,0,0,0,DP4,0,F4,F4
 .db C4,C4,0,C4,Bb3,0,G3,0
 .db 0,0,F4,DP4,F4,0,C4,0
 .db C4,0,0,0,DP4,0,F4,F4
 .db C4,C4,0,C4,Bb3,0,G3,0
 .db 0,0,F4,DP4,F4,0,C4,0
 .db C4,0,0,0,DP4,0,F4,F4
 .db C4,C4,0,C4,Bb3,0,G3,0
 .db DP4,0,DP4,0,CP4,DP4,GP4,0
 .db 0,0,FP4,0,DP4,0,GP4,0
 .db 0,0,GP4,FP4,DP4,0,CP4,0
 .db 0,0,Bb3,0,0,0,CP4,DP4
 .db DP4,0,DP4,0,CP4,DP4,GP4,0
 .db 0,0,FP4,0,DP4,0,GP4,0
 .db 0,0,GP4,FP4,DP4,0,Bb4,0
